#include <fstream.h>
#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

// #define DEBUG

void main(int argc, char **argv) {
  int i,j,k;

  if (argc<2) {
    cout << "Arguments: <filenamebase>"<<endl;
    exit(-1);
  }

  ifstream infs;
  ofstream outfs;

  char infilename[4096];
  char outfilename[4096];
  sprintf(infilename,"%s",argv[1]);

  infs.open(infilename);
  
  if (infs.peek()==EOF) {
    cout << "Error, unable to open input file "<<infilename<<endl;
    exit(-1);
  }

  cout << "Parsing file "<<infilename<<"..."<<endl;

  char line[4096];
  char str[5][4096];
  char foo[4096];
  int lcheck=0;
  int indata=0;
  int incorrect=0;


  sprintf(outfilename,"%scorrect",argv[1]);
  outfs.open(outfilename);
  cout << "\tParsing correct results... "<<flush;
  
  while(infs.peek()!=EOF) {
    if (!incorrect) 
      infs.getline(line,4096);
    if (incorrect) {
      int startval, stopval;
#ifdef DEBUG
      cout << "line is :"<<line<<endl;
#endif
      // detect start number from line
      for (i=1;i<strlen(line);i++) 
	if (line[i-1] == '.' && line[i] == '.') {
	  for (j=i-2;j>0;j--) 
	    if (line[j]<48||line[j]>57) break;
	  // now we have j+1 as the start pos and i-2 as the last pos.
#ifdef FULLDEBUG
	  cout << "i-2="<<i-2<<", j+1="<<j+1<<endl;
#endif
	  if (j>i-3) startval = 0; 
	  else {
#ifdef FULLDEBUG
	    cout << "j+1="<<j+1<<", i-1="<<i-1<<endl;
#endif
	    for (k=j+1;k<i-1;k++) {
	      foo[k-j-1] = line[k];
#ifdef FULLDEBUG
	      cout << k << ": foo["<<k-j-1<<"] = "<<foo[k-j-1]<<" ";
#endif
	    }
	    foo[k-j-1] = '\0';
	    startval = atoi(foo);
#ifdef FULLDEBUG
	    cout << " => foo is "<<foo<<endl;
#endif
	  }
	  i = strlen(line)+1;
	}	
            
      k=j=0;
      // detect stop number from line (last number overall)
      for (i=strlen(line)-1;i>-1;i--) {
	if (!j&&(line[i]>47&&line[i]<58)) {
	  j = i;
#ifdef FULLDEBUG
	  cout << "j = "<<j<<" '"<<line[j]<<"'"<<endl;
#endif
	}
	if (j&&!k) {
#ifdef FULLDEBUG
	  cout << "j&&!k: '"<<line[i]<<"' ("<<(int)line[i]<<")"<<endl;
#endif
	  if (line[i]<48||line[i]>57) {
	    k = i+1;
#ifdef FULLDEBUG
	    cout << "k = "<<k<<" '"<<line[k]<<"'"<<endl;
#endif
	  }
	}
	if (j&&k) break;
      }
      if (k>j) stopval = 0; 
      else {
	for (i=k;i<j+1;i++)
	  foo[i-k] = line[i];
	foo[i] = '\0';
	stopval = atoi(foo);
#ifdef FULLDEBUG
	cout << "foo is "<<foo<<endl;
#endif
      }
#ifdef DEBIG      
      cout << "Detected values "<<startval<< " and " << stopval<<endl;
#endif
      outfs << "#"<<startval << " " << stopval<<endl;
      incorrect=0;
      char *testline = "/translation=\"";
      while(!incorrect) {
	infs.getline(line,4096);
        sscanf(line,"%s",foo);
	incorrect = 1;
	for (i=0;i<strlen(testline);i++) if (foo[i]!=testline[i]) incorrect = 0;
      }
      outfs<<&foo[strlen(testline)]<<flush;
      while (incorrect) {
	infs.getline(line,4096);
        sscanf(line,"%s",foo);
	for (i=0;i<strlen(foo);i++)
	  if (foo[i]=='\"') {
	    foo[i]='\0';
	    incorrect=0;
	  }
	outfs<<foo<<flush;
      }
      outfs<<endl<<":"<<endl;
    } else if (indata) {
      infs.getline(line,4096);
      for (i=0;i<5;i++)
	str[i][0] = '\0';
      sscanf(line," %s %s %s %s %s %s",foo,str[0],str[1],str[2],str[3],str[4]);
      lcheck = atoi(foo);
#ifdef DEBUG
      cout << lcheck << " " << flush;
#endif 
      if (!lcheck) {
	indata = 0;
	outfs.close();
	cout << "Data parsed into "<<outfilename<<endl;
      } else {
	for (i=0;i<5;i++)
	  outfs << str[i];
	outfs << endl;
      }      
    } else {
      sscanf(line,"%s %s",str[0],str[1]);

      int cdsdet=0;
      for (i=3;i<strlen(line);i++) {
	if (!cdsdet && line[i-2] == 'C' && line[i-1] == 'D' && line[i] == 'S') 
	  cdsdet = 1;
	if (cdsdet && line[i-1] == '.' && line[i] == '.') 
	  cdsdet = 2;
      }
#ifdef FULLDEBUG
      cout << "## line is: '"<<line<<"', CDSDET = "<<cdsdet<<endl;
#endif
      if (cdsdet==2) {
	incorrect = 1;     
      } else if (!strcmp(str[0],"BASE")&&!strcmp(str[1],"COUNT")) {
	infs.getline(line,4096);
	sscanf(line,"%s",str[0]);
	if (!strcmp(str[0],"ORIGIN")) {
	  indata=1;
	  cout << "Correct results are in "<<outfilename<<endl;      
	  sprintf(outfilename,"%sdata",argv[1]);
	  outfs.close();
	  outfs.open(outfilename);
	  cout << "\tParsing data... "<<flush;
	}
      }
    }
  }

  cout << "DONE!"<<endl;
  infs.close();
  outfs.close();
}

